/*
*********************************************************************
thermalRead

Control Plus
www.controlplus.biz
12 OCT 2007

*********************************************************************/

#define VERSION "0.9.0"
#include "serialBuffer.h"
//-------------------------------------------------------------------------------------------------
int getparameter(serialBuffer *port,int parameter, int *result)
{
	int werr;
	Byte data[28];
	int len = 0;
	Byte inByte;
	int rxState = 0;
	int returnResult = -1;
	int MSB;
	
	data[len++] = 0x08;
	data[len++] = parameter;

	werr = write(port->port,data,len);
	if(werr>=0)
	{
	//the write was OK so start to read
		while(rxState!=2)
		{
			if(getOneByte(&inByte,port))
			{
				switch(rxState)
				{
				case 0:// expecting the lst byte 0x0E
					MSB = (char)inByte;
					rxState = 1;
					break;
				case 1:// Roll MSB
					*result = (MSB*256 + inByte);
					rxState = 2;
					break;
				}
			}
			else
			{
				// no data received - timeout and return;
				returnResult = -1;
				break;
			}
		}
		if(rxState==2)
		{
			returnResult = 0;
		}
	}
	else
	{
		// the write to PM2000 failed
		printf("write to GX1 error = %d\n",werr);
		returnResult = werr;
	
	}
	return returnResult;
}
//-------------------------------------------------------------------------------------------------

int main (int argc, char** argv)
{
	int i,j;
	int lockresult = 0;
	int presult = 0;
	serialBuffer *SB;
	int port;
	int rerr;
	int data;
	
	printf("Thermal inclinometer parameter read application\n");
	printf("COPYRIGHT 2005 Control Plus\n");
	printf("www.controlplus.biz\n");
	printf("VERSION %s %s %s\n",VERSION,__DATE__, __TIME__);
	if(argc<2) 
	{
		printf("\nERROR usage: thermalread port\n");
		return 0;
	}
	
	port = OpenPort(argv[1],38400,5); // open a serial port at 38400 baud with a 0.5 second timeout on rx
	
	if(port==-1)
		printf("could not open port %s\n",argv[1]);
	else
	{
		SB = newSerialBuffer(port);
		for(i=0;i<16;i++)
		{
			rerr = getparameter(SB,i,&data);
			if(rerr==0)
			{
				printf("%d\t%d\n",i,data);
			
			}
		}
	}
		
	
}

